//+------------------------------------------------------------------+
//|                                                      i_FD_FS.mq4 |
//|                                                                  |
//|                                             dmfedoseev@yandex.ru |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "dmfedoseev@yandex.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Gray


//---- input parameters

extern int       i_Period=240;

extern int       i_Harmonics=7;

int LastTime;
double A[],B[],R[],RM[];
int RN[];
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
 
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);   
   SetIndexShift(1,i_Period);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(Time[0]!=LastTime){
      LastTime=Time[0];
      
      for(int i=0;i<Bars;i++){
         ExtMapBuffer1[i]=EMPTY_VALUE;
         ExtMapBuffer2[i]=EMPTY_VALUE;      
      }
         
         //  
         int N=i_Period;
         int M=MathFloor(N/2);
         ArrayResize(A,M);
         ArrayResize(B,M);  
         ArrayResize(R,M); 
                                  
            for (i=0;i<M;i++){
               A[i]=0;
               B[i]=0;
                  for(int j=0;j<N;j++){
                     A[i]+=Price(j,"c")*MathCos(i*6.28*j/N);
                     B[i]+=Price(j,"c")*MathSin(i*6.28*j/N);
                  }
               A[i]=2*A[i]/N;
               B[i]=2*B[i]/N;  
               R[i]=MathSqrt(MathPow(A[i],2)+MathPow(B[i],2));
            }
            

         ArrayResize(RM,i_Harmonics+1);          
         ArrayResize(RN,i_Harmonics+1);             
            for(i=1;i<M;i++){
               for(j=1;j<i_Harmonics+1;j++){
                  if(R[i]>RM[j]){
                     RM[j]=R[i];
                     RN[j]=i;
                     break;
                  }
               }
            
            }            
            
            for(i=0;i<N;i++){
               ExtMapBuffer1[i]=A[0]/2;
                  for(j=1;j<i_Harmonics+1;j++){
                     ExtMapBuffer1[i]+=A[j]*MathCos(j*6.28*i/(N-1))+B[j]*MathSin(j*6.28*i/(N-1));
                  }
            }
            
            
            for(i=0;i>-N;i--){
               ExtMapBuffer2[N+i]=A[0]/2;
                  for(j=1;j<i_Harmonics+1;j++){
                     ExtMapBuffer2[N+i]+=A[j]*MathCos(j*6.28*i/(N-1))+B[j]*MathSin(j*6.28*i/(N-1));
                  }
            }            
            
            
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+

double Price(int ii, string PT){
   if(PT=="c" || PT=="C"){
      return(Close[ii]);
   }
}